/*
 * Copyright 2014 frankmuenster.de
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald diese von der
 * Europischen Kommission genehmigt wurden - Folgeversionen der EUPL
 * ("Lizenz"); Sie drfen dieses Werk ausschlielich gem dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 * http://ec.europa.eu/idabc/eupl
 * Sofern nicht durch anwendbare Rechtsvorschriften gefordert oder in
 * schriftlicher Form vereinbart, wird die unter der Lizenz verbreitete Software
 * "so wie sie ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet. Die sprachspezifischen
 * Genehmigungen und Beschrnkungen unter der Lizenz sind dem Lizenztext zu
 * entnehmen.
 */

package de.frankmuenster.jameica.depot.db.rmi;

import java.rmi.RemoteException;

import de.willuhn.datasource.rmi.DBService;
import de.willuhn.util.ApplicationException;

/**
 * Interface to our DBService
 * 
 * @author munstfr
 * 
 */
public interface JaDepotDBService extends DBService {

	/**
	 * Initialisiert/erzeugt die Datenbank.
	 * 
	 * @throws RemoteException
	 *             Wenn beim Initialisieren ein Fehler auftrat.
	 */
	void install() throws RemoteException;

	/**
	 * &Uuml;berpr&uuml;ft die Konsistenz der Datenbank und f&uuml;hrt bei
	 * Bedarf Updates durch.
	 * 
	 * @throws RemoteException
	 *             Wenn es beim der &Uuml;berpr&uuml;fung zu einem Fehler kam.
	 * @throws ApplicationException
	 *             Wenn die Datenbank-Konsistenz nicht gew%auml;hrleistet ist.
	 */
	void checkConsistency() throws RemoteException, ApplicationException;

}
