/*
 * Copyright 2016 frankmuenster.de
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald diese von der
 * Europischen Kommission genehmigt wurden - Folgeversionen der EUPL
 * ("Lizenz"); Sie drfen dieses Werk ausschlielich gem dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 * http://ec.europa.eu/idabc/eupl
 * Sofern nicht durch anwendbare Rechtsvorschriften gefordert oder in
 * schriftlicher Form vereinbart, wird die unter der Lizenz verbreitete Software
 * "so wie sie ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet. Die sprachspezifischen
 * Genehmigungen und Beschrnkungen unter der Lizenz sind dem Lizenztext zu
 * entnehmen.
 */

package de.frankmuenster.jameica.depot.finanzen.currencyexchangerate;

import java.util.Date;

import de.frankmuenster.jameica.depot.finanzen.yahoo.finance.YahooFinanceException;

/**
 * 
 * Interface f%uuml;r W&auml;hrungsumrechner
 * 
 * @author munstfr
 * 
 */
public interface ICurrencyExchangeRate {

	/**
	 * Umstauschraten basierend auf aktuellem Umrechnungskurs.
	 * 
	 * @param currencyFrom
	 *            die Ausgangsw&auml;hrung
	 * @param currencyTo
	 *            die Zielsw&auml;hrung
	 * @return Die Umstauschrate
	 * @throws YahooFinanceException
	 *             wenn irgendwas schief ging.
	 */
	float exchangeRate(final String currencyFrom, final String currencyTo)
			throws YahooFinanceException;

	/**
	 * Umstauschraten basierend auf angegeben Datum.
	 * 
	 * @param currencyFrom
	 *            die Ausgangsw&auml;hrung
	 * @param currencyTo
	 *            die Zielsw&auml;hrung
	 * @param date
	 *            das Datum des Umstausches
	 * @return Die Umstauschrate
	 * @throws YahooFinanceException
	 *             wenn irgendwas schief ging.
	 */
	float exchangeRate(final String currencyFrom, final String currencyTo, final Date date)
			throws YahooFinanceException;

}
