/*
 * Copyright 2016 frankmuenster.de
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald diese von der
 * Europischen Kommission genehmigt wurden - Folgeversionen der EUPL
 * ("Lizenz"); Sie drfen dieses Werk ausschlielich gem dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 * http://ec.europa.eu/idabc/eupl
 * Sofern nicht durch anwendbare Rechtsvorschriften gefordert oder in
 * schriftlicher Form vereinbart, wird die unter der Lizenz verbreitete Software
 * "so wie sie ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet. Die sprachspezifischen
 * Genehmigungen und Beschrnkungen unter der Lizenz sind dem Lizenztext zu
 * entnehmen.
 */

package de.frankmuenster.jameica.depot.finanzen.yahoo.finance;

import java.util.Date;

/**
 * Bean der YAHOO Umrechnungsraten abbildet.
 * 
 * @author munstfr
 * @version 1.0
 *
 */
public class CurrencyToUsdExchangeRate {

	/**
	 * der Yahoo Klasse des Wertpapiers (hier immer Quote).
	 */
	private String className;
	
	/**
	 * Das Datum der Umrechnugsrate
	 */
	private Date date;
	
	/**
	 * Die Rate immer relativ zum, US-Dollar
	 */
	private float price;
	
	/**
	 * Das Symbol (normalerweise das W&auml;hrungssysmbol mit nachgestelletem =X. Z.B. <b>EUR=X</b>.
	 */
	private String symbol;
	
	/**
	 * Der Yahoo-Type des Wertpapier (hier immer currency). 
	 */
	private String type;
	
	
	/**
	 * Standartkonstruktor
	 */
	public CurrencyToUsdExchangeRate() { // NOPMD 
		// ct.
	}
	
	/**
	 * @return the className
	 */
	public String getClassName() {
		return className;
	}
	/**
	 * @return the date
	 */
	public Date getDate() {
		return date;
	}
	/**
	 * @return the price
	 */
	public float getPrice() {
		return price;
	}
	/**
	 * @return the symbol
	 */
	public String getSymbol() {
		return symbol;
	}
	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}
	/**
	 * @param className the className to set
	 */
	public void setClassName(final String className) {
		this.className = className;
	}
	/**
	 * @param date the date to set
	 */
	public void setDate(final Date date) {
		this.date = date;
	}
	/**
	 * @param price the price to set
	 */
	public void setPrice(final float price) {
		this.price = price;
	}
	/**
	 * @param symbol the symbol to set
	 */
	public void setSymbol(final String symbol) {
		this.symbol = symbol;
	}
	/**
	 * @param type the type to set
	 */
	public void setType(final String type) {
		this.type = type;
	}

}
