/*
 * Copyright 2016 frankmuenster.de
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie drfen dieses Werk ausschlielich gem
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 * http://ec.europa.eu/idabc/eupl
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschrnkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */

package de.frankmuenster.jameica.depot.gui.input;

import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.mihalis.opal.rangeSlider.RangeSlider;

/**
 * Listener der &Auml;nderungen an dem Zeitauswahlschieber verarbeitet.
 * 
 * @author munstfr
 * @version 1.0
 * 
 */
public class ZeitauswahlSchieberInputChangedListener implements KeyListener,
		MouseMoveListener, SelectionListener {

	/**
	 * Der Zeitauswahlschieber f&uer die Callback-Aufrufe
	 */
	private final transient ZeitauswahlSchieberInput source;

	/**
	 * Konstruktor mit Angabe des Source Zeitauswahlschiebers
	 * 
	 * @param source
	 */
	public ZeitauswahlSchieberInputChangedListener(
			final ZeitauswahlSchieberInput source) {
		this.source = source;
	}

	/**
	 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(SelectionEvent)
	 */
	@Override
	public void widgetDefaultSelected(final SelectionEvent arg0) {
		// Hier nix machen

	}

	/**
	 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(SelectionEvent)
	 */
	@Override
	public void widgetSelected(final SelectionEvent arg0) {
		handleAction();

	}

	/**
	 * @see org.eclipse.swt.events.MouseMoveListener#mouseMove(MouseEvent)
	 */
	@Override
	public void mouseMove(final MouseEvent arg0) {
		handleAction();
	}

	/**
	 * @see org.eclipse.swt.events.KeyListener#keyPressed(KeyEvent)
	 */
	@Override
	public void keyPressed(final KeyEvent arg0) {
		// Hier nix machen

	}

	/**
	 * @see org.eclipse.swt.events.KeyListener#keyReleased(KeyEvent)
	 */
	@Override
	public void keyReleased(final KeyEvent arg0) {
		handleAction();
	}

	/**
	 * Private Funktion, die sich um die &Auml;nderungen k&uuml;mmert.
	 */
	private void handleAction() {

		final RangeSlider slider = (RangeSlider) source.getControl();

		final int lNew = slider.getLowerValue();
		final int uNew = slider.getUpperValue();

		final int lOld = ((int[]) source.getValue())[0];
		final int uOld = ((int[]) source.getValue())[1];

		// etwas verndert
		if (lNew != lOld || uNew != uOld) {
			source.setLower(lNew);
			source.setUpper(uNew);
			source.notifyListeners();
		}
	}

}
