/*
 * Copyright 2016 frankmuenster.de
 *
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie drfen dieses Werk ausschlielich gem
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 *   http://ec.europa.eu/idabc/eupl
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschrnkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.frankmuenster.jameica.depot.gui.parts.grafiken;

import java.util.Date;

/**
 * Bean mit Datum, Wert Paaren.
 * 
 * @author munstfr
 * @version 1.0
 */
public class DateValuePair {

	/**
	 * Das Datum
	 */
	private Date date;

	/**
	 * Der Wert
	 */
	private Double value;

	/**
	 * Konstruktor mit Angabe des Datums und des Wertes.
	 * 
	 * @param date
	 * @param value
	 */
	public DateValuePair(final Date date, final Double value) {
		this.date = date;
		this.value = value;
	}

	/**
	 * @return value
	 */
	public Double getValue() {
		return value;
	}

	/**
	 * @param value
	 *            das zu setzende Objekt value
	 */
	public void setValue(final Double value) {
		this.value = value;
	}

	/**
	 * @return date
	 */
	public Date getDate() {
		return date;
	}

	/**
	 * @param date
	 *            das zu setzende Objekt date
	 */
	public void setDate(final Date date) {
		this.date = date;
	}

}
