/*
 * Copyright 2016 frankmuenster.de
 *
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie drfen dieses Werk ausschlielich gem
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 *   http://ec.europa.eu/idabc/eupl
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschrnkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */

package de.frankmuenster.jameica.depot.kursanalyse.MOM;// NOPMD

import org.jfree.chart.plot.XYPlot;

import de.frankmuenster.jameica.depot.Settings;
import de.frankmuenster.jameica.depot.kursanalyse.AbstractHandleAddAction;
import de.frankmuenster.jameica.depot.kursanalyse.IKursAnalyse;
import de.frankmuenster.jameica.depot.kursanalyse.KursAnalyseParameter;
import de.frankmuenster.jameica.depot.kursanalyse.KursAnalyseTyp;
import de.willuhn.jameica.system.OperationCanceledException;
import de.willuhn.logging.Logger;
import de.willuhn.util.ApplicationException;

/**
 * Momentum HandleAddAction
 * 
 * @author munstfr
 * @version 1.0
 */
public class MomentumHandleAddAction extends AbstractHandleAddAction {

	/**
	 * Standardkonstruktor
	 */
	public MomentumHandleAddAction() {
		super();
	}

	/**
	 * @see de.willuhn.jameica.gui.Action#handleAction(Object context)
	 */
	@Override
	public void handleAction(final Object context) throws ApplicationException {

		Logger.info(Settings.getI18n().tr("MomentumHandleAddAction.logAdd")); //$NON-NLS-1$
		handleAdd();
	}

	private void handleAdd() {

		final MomentumAddDialog dialog = new MomentumAddDialog();
		int period = 0;
		try {
			period = (Integer) dialog.open();
		} catch (OperationCanceledException oce) {
			Logger.info(Settings.getI18n().tr(
					"MomentumHandleAddAction.logAddCanceled")); //$NON-NLS-1$
		} catch (Exception e) { // NOPMD
			Logger.error(
					Settings.getI18n()
							.tr("MomentumHandleAddAction.logAddError"), //$NON-NLS-1$
					e);
		}

		if (period > 0) {
			final MomentumParameter momPara = new MomentumParameter();
			momPara.setPeriod(period);

			final KursAnalyseParameter<MomentumParameter> para = new KursAnalyseParameter<MomentumParameter>(
					momPara);

			final IKursAnalyse<MomentumParameter, XYPlot> mom = new Momentum();
			mom.setKursAnalyseParameter(para);
			mom.setType(KursAnalyseTyp.SEPERATE_GRAPH);

			// Call listener
			notifyListeners(mom);
		}
	}

}
