/*
 * Copyright 2016 frankmuenster.de
 *
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie drfen dieses Werk ausschlielich gem
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 *   http://ec.europa.eu/idabc/eupl
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschrnkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */

package de.frankmuenster.jameica.depot.kursanalyse.SMA; // NOPMD

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import de.frankmuenster.jameica.depot.Settings;
import de.frankmuenster.jameica.depot.kursanalyse.dialog.AbstractAddAnalyseDialog;
import de.willuhn.jameica.gui.Action;
import de.willuhn.jameica.gui.dialogs.AbstractDialog;
import de.willuhn.jameica.gui.input.IntegerInput;
import de.willuhn.jameica.gui.parts.ButtonArea;
import de.willuhn.jameica.gui.util.Container;
import de.willuhn.jameica.gui.util.SimpleContainer;
import de.willuhn.util.ApplicationException;

/**
 * SimpleMovingAverage AddDialog
 * 
 * @author munstfr
 * @version 1.0
 */
public class SimpleMovingAverageAddDialog extends
		AbstractAddAnalyseDialog<Integer> {

	/**
	 * Standardwert
	 */
	private transient int result = 50;

	/**
	 * Erzeugt einen neuen AddDialog
	 */
	public SimpleMovingAverageAddDialog() {
		super(AbstractDialog.POSITION_CENTER, false);
		this.setTitle(Settings.getI18n().tr(
				"SimpleMovingAverageAddDialog.dialogTitle")); //$NON-NLS-1$
		this.setSize(270, 160);
	}

	/**
	 * @see de.willuhn.jameica.gui.dialogs.AbstractDialog#paint(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected void paint(final Composite parent) {

		final GridLayout layout = new GridLayout();
		layout.numColumns = 1;
		parent.setLayout(layout);

		// Erstelle einfachen Container
		final Container container = new SimpleContainer(parent, true, 2);

		final IntegerInput period = new IntegerInput();
		period.setHint(Integer.toString(result));
		period.setName(Settings.getI18n().tr(
				"SimpleMovingAverageAddDialog.lblName")); //$NON-NLS-1$
		container
				.addLabelPair(
						Settings.getI18n().tr(
								"SimpleMovingAverageAddDialog.lblPeriod"), //$NON-NLS-1$
						period);
		container.addText(" ", false); //$NON-NLS-1$

		final ButtonArea buttons = new ButtonArea();
		buttons.addButton(
				Settings.getI18n().tr("SimpleMovingAverageAddDialog.btnAdd"), //$NON-NLS-1$
				new Action() {
					/**
					 * @see de.willuhn.jameica.gui.Action#handleAction(java.lang.Object)
					 */
					@Override
					public void handleAction(final Object context)
							throws ApplicationException {
						if (period.getValue() == null) {
							result = 50;
						} else {
							result = (Integer) period.getValue();
						}
						close();
					}
				}, null, true, "ok.png"); //$NON-NLS-1$

		buttons.addButton(
				Settings.getI18n().tr("SimpleMovingAverageAddDialog.btnCancel"), //$NON-NLS-1$
				new Action() {
					/**
					 * @see de.willuhn.jameica.gui.Action#handleAction(java.lang.Object)
					 */
					@Override
					public void handleAction(final Object context)
							throws ApplicationException {
						result = 0;
						close();
					}
				}, null, false, "window-close.png"); //$NON-NLS-1$

		container.addButtonArea(buttons);

	}

	/**
	 * @see de.willuhn.jameica.gui.dialogs.AbstractDialog#getData()
	 */
	@Override
	protected Integer getData() {
		return this.result;
	}

}
