/*
 * Copyright 2016 frankmuenster.de
 *
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie drfen dieses Werk ausschlielich gem
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 *   http://ec.europa.eu/idabc/eupl
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschrnkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */

package de.frankmuenster.jameica.depot.wertpapierorder; // NOPMD 

import java.util.Date;

/**
 * Interface das ein Order-Objekt beschreibt.
 * 
 * @author munstfr
 * @version 1.0
 */
@SuppressWarnings("PMD.LongVariable")
public interface Order {

	/**
	 * @return additionalCosts
	 */
	double getAdditionalCosts();

	/**
	 * @return additionalCostsInMainCurrency
	 */
	double getAdditionalCostsInMainCurrency();

	/**
	 * @return additionalCostsMainCurrency
	 */
	String getAdditionalCostsCurrency();

	/**
	 * @return comment
	 */
	String getComment();

	/**
	 * @return name
	 */
	String getName();

	/**
	 * @return orderDate
	 */
	Date getOrderDate();

	/**
	 * @return orderPrice
	 */
	double getOrderPrice();

	/**
	 * @return orderPriceInMainCurrency
	 */
	double getOrderPriceInMainCurrency();

	/**
	 * @return orderPriceTotal
	 */
	double getOrderPriceTotal();

	/**
	 * @return orderVolume
	 */
	double getOrderVolume();

	/**
	 * @return symbol
	 */
	String getSymbol();

	/**
	 * @param additionalCosts
	 *            das zu setzende Objekt additionalCosts
	 */
	void setAdditionalCosts(double additionalCosts);

	/**
	 * @param additionalCostsInMainCurrency
	 *            das zu setzende Objekt additionalCostsInMainCurrency
	 */
	void setAdditionalCostsInMainCurrency(double additionalCostsInMainCurrency);

	/**
	 * @param additionalCostsMainCurrency
	 *            das zu setzende Objekt additionalCostsMainCurrency
	 */
	void setAdditionalCostsCurrency(String additionalCostsMainCurrency);

	/**
	 * @param comment
	 *            das zu setzende Objekt comment
	 */
	void setComment(String comment);

	/**
	 * @param name
	 *            das zu setzende Objekt name
	 */
	void setName(String name);

	/**
	 * @param date
	 *            das zu setzende Objekt orderDate
	 */
	void setOrderDate(Date date);

	/**
	 * @param orderPrice
	 *            das zu setzende Objekt orderPrice
	 */
	void setOrderPrice(double orderPrice);

	/**
	 * @param orderPriceInMainCurrency
	 *            das zu setzende Objekt orderPriceInMainCurrency
	 */
	void setOrderPriceInMainCurrency(double orderPriceInMainCurrency);

	/**
	 * @param orderPriceTotal
	 *            das zu setzende Objekt orderPriceTotal
	 */
	void setOrderPriceTotal(double orderPriceTotal);

	/**
	 * @param orderVolume
	 *            das zu setzende Objekt orderVolume
	 */
	void setOrderVolume(double orderVolume);

	/**
	 * @param symbol
	 *            das zu setzende Objekt symbol
	 */
	void setSymbol(String symbol);

}