/*
 * Copyright 2016 frankmuenster.de
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie drfen dieses Werk ausschlielich gem
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 * http://ec.europa.eu/idabc/eupl
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschrnkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.frankmuenster.jameica.depot.wertpapierorder;

import java.util.Date;

/**
 * Implementierung einer Order-Bean
 * 
 * @author munstfr
 * @version 1.0
 */
@SuppressWarnings("PMD.LongVariable")
public class OrderImpl implements Order {

	/**
	 * Das Symbol
	 */
	private String symbol;

	/**
	 * Der name des WP
	 */
	private String name;

	/**
	 * Das Order Datum
	 */
	private Date orderDate;

	/**
	 * Das Order Volumen
	 */
	private double orderVolume;

	/**
	 * Der Order-Preis
	 */
	private double orderPrice;

	/**
	 * Der Order-Preis in der Hauptw&auml;hrung
	 */
	private double orderPriceInMainCurrency;

	/**
	 * Die zus&auml;tzlichen Kosten
	 */
	private double additionalCosts;

	/**
	 * Die W&auml;hrung derzus&auml;tzlichen Kosten
	 */
	private String additionalCostsCurrency;

	/**
	 * Die zus&auml;tzlichen Kosten in der haupw&auml;hrung
	 */
	private double additionalCostsInMainCurrency;

	/**
	 * Kommantar
	 */
	private String comment;

	/**
	 * Standardkonstruktor
	 */
	public OrderImpl() {
		// Absichlich leer
	}

	/**
	 * @see Order#getSymbol()
	 */
	@Override
	public String getSymbol() {
		return symbol;
	}

	/**
	 * @see Order#setSymbol(String)
	 */
	@Override
	public void setSymbol(final String symbol) {
		this.symbol = symbol;
	}

	/**
	 * @see Order#getName()
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * @see Order#setName(String)
	 */
	@Override
	public void setName(final String name) {
		this.name = name;
	}

	/**
	 * @see Order#getOrderDate()
	 */
	@Override
	public Date getOrderDate() {
		return orderDate;
	}

	/**
	 * @see Order#setOrderDate(Date)
	 */
	@Override
	public void setOrderDate(final Date orderDate) {
		this.orderDate = orderDate;
	}

	/**
	 * @see Order#getOrderVolume()
	 */
	@Override
	public double getOrderVolume() {
		return orderVolume;
	}

	/**
	 * @see Order#setOrderVolume(double)
	 */
	@Override
	public void setOrderVolume(final double orderVolume) {
		this.orderVolume = orderVolume;
	}

	/**
	 * @see Order#getOrderPrice()
	 */
	@Override
	public double getOrderPrice() {
		return orderPrice;
	}

	/**
	 * @see Order#setOrderPrice(double)
	 */
	@Override
	public void setOrderPrice(final double orderPrice) {
		this.orderPrice = orderPrice;
	}

	/**
	 * @see Order#getOrderPriceInMainCurrency()
	 */
	@Override
	public double getOrderPriceInMainCurrency() {
		return orderPriceInMainCurrency;
	}

	/**
	 * @see Order#setOrderPriceInMainCurrency(double)
	 */
	@Override
	public void setOrderPriceInMainCurrency(
			final double orderPriceInMainCurrency) {
		this.orderPriceInMainCurrency = orderPriceInMainCurrency;
	}

	/**
	 * @see Order#getAdditionalCosts()
	 */
	@Override
	public double getAdditionalCosts() {
		return additionalCosts;
	}

	/**
	 * @see Order#setAdditionalCosts(double)
	 */
	@Override
	public void setAdditionalCosts(final double additionalCosts) {
		this.additionalCosts = additionalCosts;
	}

	/**
	 * @see Order#getAdditionalCostsInMainCurrency()
	 */
	@Override
	public double getAdditionalCostsInMainCurrency() {
		return additionalCostsInMainCurrency;
	}

	/**
	 * @see Order#setAdditionalCostsInMainCurrency(double)
	 */
	@Override
	public void setAdditionalCostsInMainCurrency(
			final double additionalCostsInMainCurrency) {
		this.additionalCostsInMainCurrency = additionalCostsInMainCurrency;
	}

	/**
	 * @see Order#getAdditionalCostsCurrency()
	 */
	@Override
	public String getAdditionalCostsCurrency() {
		return additionalCostsCurrency;
	}

	/**
	 * @see Order#setAdditionalCostsCurrency(String)
	 */
	@Override
	public void setAdditionalCostsCurrency(final String additionalCostsCurrency) {
		this.additionalCostsCurrency = additionalCostsCurrency;
	}

	/**
	 * @see Order#getComment()
	 */
	@Override
	public String getComment() {
		return comment;
	}

	/**
	 * @see Order#setComment(String)
	 */
	@Override
	public void setComment(final String comment) {
		this.comment = comment;
	}

	/**
	 * @see Order#getOrderPriceTotal()
	 */
	@Override
	public double getOrderPriceTotal() {
		return getOrderVolume() * getOrderPrice();
	}

	/**
	 * @see Order#setOrderPriceTotal(double)
	 */
	@Override
	public void setOrderPriceTotal(final double orderPriceTotal) {
		// TODO: Mal schauen
	}
}
